"""

Python Desktop Server - Shutdown Tool

Copyright (c) 2004, Thomas Klaeger <tkl@10a.ch>

Permission is hereby granted, free of charge, to any person obtaining a copy of 
this software and associated documentation files (the "Software"), to deal in 
the Software without restriction, including without limitation the rights to 
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 
the Software, and to permit persons to whom the Software is furnished to do so, 
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

"""

# $Id: ShutdownTool.py,v 1.5 2004/05/31 13:26:28 gb Exp $

import PyDS.Server
import PyDS.Tool
import asyncore
import sys
import time
import threading

class ShutdownTool(PyDS.Tool.StandardTool):

	def _initopts(self):
		self.hasAPI = 1
		self.shutdown = 0
		self.background = None

	# Initiate shutdown. 
	def startShutdown(self): 
		"Initiate shutdown, returning 1 if started or 0 if already started."
		if self.background: 
			return 0
		
		def thunk():
			time.sleep(2)
			self.log('Shutting down!')
			# close all sockets
		        map (lambda x: x.close(), asyncore.socket_map.values())
		        # shutdown all threads
			PyDS.Server.terminate()

		self.background = threading.Thread(
			target=thunk,
			args=[],
			kwargs={}
		)
		self.background.start()
		return 1

	def index_html(self, req): 
		res = self.startShutdown()
		desc = [_('Shutdown previously started.'), 
		        _('Shutdown started.')][res]
		html = "<p>%s: %s</p><p>%s</p>" % (self.title, self.desc, desc)
		return req.renderPage('BaseTemplate', body=html)

		
__desc__ = _("Shut down PyDS")

PyDS.Tool.registerTool(ShutdownTool, 'shutdown', _('Shutdown'), __desc__, 999)

