"""

Python Desktop Server - Status panel

Copyright (c) 2002, Georg Bauer <gb@murphy.bofh.ms>

Permission is hereby granted, free of charge, to any person obtaining a copy of 
this software and associated documentation files (the "Software"), to deal in 
the Software without restriction, including without limitation the rights to 
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 
the Software, and to permit persons to whom the Software is furnished to do so, 
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

"""

# $Id: StatusTool.py,v 1.9 2004/01/28 14:32:14 gb Exp $

import sys
import time
import string
import traceback

import PyDS.Tool

class StatusTool(PyDS.Tool.StandardTool):

	def _initdb(self):
		self.importantTool = 1

	def _initopts(self):
		self.hasAPI = 0
	
	def index_html(self, req):
		try:
			self._acquire()
			html = ''
			for tool in PyDS.Tool.getTools():
				if hasattr(tool, '_status'):
					try:
						html += tool._status()
					except:
						html += _('<p>There was an error getting the status of tool %s!') % tool.name
						(e, d, tb) = sys.exc_info()
						html += _('<br><b>Exception %s: %s</b>') % (e, d)
						html += '<table border=0>'
						html += _('<tr><th>File</th><th>Line</th><th>Function</th><th>Source</th></tr>')
						for row in traceback.extract_tb(tb):
							html += '<tr>'
							(file, line, function, source) = row
							file = file.split('/')[-1]
							html += '<td>%s</td>' % file
							html += '<td>%s</td>' % line
							html += '<td>%s</td>' % function
							html += '<td>%s</td>' % source
							html += '</tr>'
						html += '</table>'
			req.setLocalValue('title', _('Status of tools'))
			return req.renderPage('BaseTemplate', body=html)
		finally: self._release()
		
__desc__ = _("This tool gives a status of installed tools that support it.")

PyDS.Tool.registerTool(StatusTool, 'status', _('Status'), __desc__, 900)
